=== debian/watch ===
version=4

https://github.com/fraunhoferhhi/vvenc/releases \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@
